#!/usr/bin/env perl

use strict;
use AppConfig;
use Graph;
use Graph::Writer::Dot;
use RDF::Trine;
use RDF::Trine::Store::Memory;
use RDF::Trine::Node::Literal;
use RDF::Trine::Statement::Quad;
use RDF::Trine::Model;
use RDF::Trine::Serializer;
use RDF::Trine::Namespace qw(rdf owl);
use POSIX;
use Text::Table;
use XML::Generator;
use List::Util::XS;
use List::Util qw{min max};
my $config = AppConfig->new(
			    'verbose|v!' => {DEFAULT => 0},
			    'output|o=f' => {DEFAULT => 'toto'},
			    'html!' => {DEFAULT => 0},
			    'rdf!' => {DEFAULT => 0},
			    'tree!' => {DEFAULT => 0},
			    'graph!' => {DEFAULT => 1},
			    'graphstats!' => {DEFAULT => 0},
			    'distrib!' => {DEFAULT => 0},
			    'owl!' => {DEFAULT => 0},
			    'toefl=f',
			    'wordnet=f',
			    'xwordnet=f',
			    'connectivity!' => {DEFAULT=>0},
			    'tulip!' => {DEFAULT => 0},
			    'wndump=f' # read from a wordnet rather from a dump
			   );

my $args = join(' ',@ARGV);

$config->args;

my $base = $config->output;

my %nodes = ();

my $ctr = 0;
my $n=0;
my $xsource;
my $xtarget;

## for wordnet
my %pos = ( n => 'nc',
	    v => 'v',
	    a => 'adj',
	    b => 'adv'
	  );

sub normalize_name {
  my $s = shift;
  $s =~ s/"//og;
  return $s;
}

if (my $wndump = $config->wndump) {
  my $wn = load_wordnet($wndump);
  foreach my $w (keys %$wn) {
    $xsource = $nodes{$w} ||= { id => $ctr++,
				 name => normalize_name($w),
				 adjacencies => {}
			       };
    my $adj = $wn->{$w};
    $nodes{$_} ||= { id => $ctr++,
		     name => normalize_name($_),
		     adjacencies => {}
		   } foreach (keys %$adj);
    foreach my $w2 (keys %$adj) {
      next if (exists $nodes{$w2}{adjacencies}{$w});
      $xsource->{adjacencies}{$w2} = 1;
    }
  }
} else {
while (<>) {
  next if (/^\s*$/);
  if (/^<\d+>\s+(.+?)\s+\(/) {
    ##    print STDERR "processing $1\n";
    my $source = $1;
    my ($n) = /n=(\d+)/o;
    $xsource = $nodes{$source}
      ||= { id => $ctr++,
	    name => normalize_name($source),
	    adjacencies => {},
	    n => $n,
	    udaj => {}
	  };
    next;
  }
  if (my ($target,$mark,$w1,$w2,$w3) = /^\t(.+?)\s+\[([+~-]).*?\]\s+(\S+)%\s+(\S+)\s+(\S+)%/) {
    my ($n) = /n=(\d+)/o;
    my $xtarget = $nodes{$target}
      ||= { id => $ctr++,
	    name => normalize_name($target),
	    adjacencies => {},
	    n => $n,
	    uadj => {}
	  };
    if ( 1 && 
	 ( $mark eq '+'
	   || exists $xtarget->{adjacencies}{$xsource->{name}}
	 )
       ) {
      $xtarget->{adjacencies}{$xsource->{name}} += $w3;
    } else {
      $xsource->{adjacencies}{$target} += $w3;
    }
    $xsource->{uadj}{$target} = 1;
    $xtarget->{uadj}{$xsource->{name}} = 1;
  }
}
}

my $g = Graph->new;

foreach my $xnode (values %nodes) {
  my $source = $xnode->{name};
  my $adj = $xnode->{adjacencies};
  foreach my $target (keys %$adj) {
    $g->add_weighted_edge($source => $target, 1 / ($adj->{$target} || 1));
    ## $g->add_edge($source => $target);
    ##    $g->set_edge_attribute($source,$target,color => 'blue');
  }
}

my $apsp; 

#$apsp = $g->APSP_Floyd_Warshall if ($config->toefl);

my $writer = Graph::Writer::Dot->new();

if ($config->tree) {
  #my  $mstg = $g->minimum_spanning_tree;
  my $mstg = $g->SPT_Dijkstra();
  $writer->write_graph($mstg,"$base.tree.dot");
}


$writer->write_graph($g,"$base.graph.dot") if ($config->graph);

if ($config->tulip) {
  my %edges=();
  my $ectr=0;
  open(TLP,">$base.graph.tlp") 
    || die "can't open '$base.graph.tlp':$!";
  sub tlp_write {
    print TLP "(";
    foreach my $x (@_) {
      my $t = ref($x);
      if ($t eq 'CODE') {
	$x->();
      } elsif ($t eq 'ARRAY') {
	print TLP "\n";
	tlp_write(@$x);
      } else {
	print TLP "$x ";
      }
    }
    print TLP ")\n";
  }
  tlp_write(
	    qw{tlp "2.0"},
	    [qw{author "dump2dot.pl"}],
	    [qw{comments "This file was generated by dump2dot"}],
	    sub {
	      my @nodes = sort {$a <=> $b}
		map {$_->{id}}
		  values %nodes;
	      tlp_write('nodes',@nodes);
	    },
	    sub {
	      foreach my $src (values %nodes) {
		my $sid = $src->{id};
		my $adj = $src->{adjacencies};
		foreach my $target (keys %$adj) {
		  my $eid = $ectr++;
		  my $tid = $nodes{$target}{id};
		  $edges{$eid} = $adj->{$target};
		  tlp_write('edge',$eid,$sid,$tid);
		}
	      }
	    },
	    [qw{property 0 string "viewLabel"},
	     [qw{default "" ""}],
	     sub {
	       foreach my $n (values %nodes) {
		 tlp_write("node",$n->{id},"\"$n->{name}\"");
	       }
	     }
	    ],
	    [qw{property 0 color "viewColor"},
	     [qw{default "(255,0,0,255)" "(255,0,0,255)"}],
	     sub {
	       my $colors = {
			     'np' => '"(255,193,193,255)"', # RosyBrown1
#			     'nc' => '"(255,48,48,255)"', # FireBrick1
			     'nc' => '"(255,165,79,255)"', # tan1
			     'v' => '"(135,206,250,255)"',
			     'adv' => '"(202,255,112,255)"', # DarkOliveGreen1
			     'adj' => '"(234,173,234,255)"', # Plum
			     'ncpred' => '"(255,215,0,255)"' # Gold
			    };
	       foreach my $n (values %nodes) {
		 my ($cat) = $n->{name} =~ /_([a-z]+)$/;
		 my $c = $colors->{$cat} || '"(255,0,0,255)"';
		 tlp_write("node",$n->{id},$c);
	       }
	     }
	    ],
	    [ qw{property 0 metric "freq"},
	      sub {
		foreach my $n (values %nodes) {
		  my $f = log($n->{n});
		  tlp_write("node",$n->{id},tlp_quote($f));
		}
	      }
	    ],
	    [ qw{property 0 metric "strength"},
	      [qw{default "0" "0"}],
	      sub {
		foreach my $eid (keys %edges) {
		  my $w = $edges{$eid};
		  tlp_write('edge',$eid,tlp_quote($w));
		}
	      }
	    ],
	    ['attributes',
	     [qw/string "name"/,tlp_quote($base)],
	    ],
# 	    [ controller =>
# 	      [ qw/DataSet "MainController"/ =>
# 		[ qw/DataSet "views"/ =>
# 		  [ qw/DataSet "view0"/ =>
# 		    [ qw/DataSet "Node Link Diagram view"/ =>
# 		      [ qw/DataSet "data"/ =>
# 			[ qw/DataSet "Display"/ =>
# 			  [qw/bool "edgeColorInterpolation" true/],
# 			  [qw/bool "edgeSizeInterpolation" true/],
# 			  [qw/bool "edgesMaxSizeToNodesSize" true/]
# 			]
# 		      ]
# 		    ]
# 		  ]
# 		]
# 	      ]
# 	    ]
	   );
  close(TLP);
}

sub tlp_quote {
  my $s = shift;
  return "\"$s\"";
}

if ($config->graphstats) {
  ## print some stats on the graph
  ##  my $ug = $g->undirected_copy_graph;
  # my $radius = $ug->radius; 
  # my $diameter = $ug->diameter;
  my $nodes = $g->vertices;
  my $edges = $g-> edges;
  my ($sparse, $dense, $complete) = $g->density_limits;
  print <<EOF;
Graph statistics:
 nodes: $nodes
 edges: $edges
 sparse: $sparse dense: $dense complete: $complete
EOF
}

rdf_dump() if ($config->rdf);

$config->distrib and distrib();

$config->owl and owl_dump();

$config->toefl and check_toefl($config->toefl);

$config->wordnet and test_wordnet($config->wordnet);

$config->xwordnet and test_xwordnet($config->xwordnet);

$config->connectivity and node_connectivity();

sub node_connectivity {
  my $best=0;
  my $pairs=0;
  my $ctr=0;
  my %words = ();
  my %colors = ();
  foreach my $w1 (keys %nodes) {
    my $e1 = $nodes{$w1};
    my $adj1 = $e1->{uadj};
    my $sons1 = 0;
    my $brothers1 = 0;
    my $id;
    foreach my $w2 (keys %$adj1) {
      next if ($w2 eq $w1);
      $sons1++;
      my $e2 = $nodes{$w2};
      my $adj2 = $e2->{uadj};
      foreach my $w3 (keys %$adj2) {
	next if ($w3 eq $w1);
	$brothers1++ if (exists $adj1->{$w3});
      }
    }
#     my $c = $sons1 ==  1
#       ? 0 
# 	: 1 -  ($brothers1 / ($sons1 * ($sons1 - 1))) ;
    my $c = (( $sons1 ==  1) ? 0 :  1 -  ($brothers1 / ($sons1 * ($sons1 - 1))));
    $e1->{connectivty} = $c;
    $e1->{sons} = $sons1;
    $c == 0 and $best++;
    $sons1 == 1 && $pairs++;
    if ($c < 0.1) {
      my @words = (keys %$adj1);
      my $color = $words{$w1} ||= ++$ctr;
      $colors{$color}{$w1} = 1;
      while (@words) {
	my $w2 = shift @words;
	my $w2color = $words{$w2} ||= $color;
	$colors{$color}{$w2} = 1;
	unless ($color eq $w2color) {
	  foreach my $w3 (keys %{$colors{$w2color}}) {
	    $words{$w3} = $color;
	    $colors{$color}{$w3} = 1;
	  }
	  delete $colors{$w2color};
	}
      }
    }
  }
  print <<STATS;
pairs:\t$pairs
best:\t$best

----------------------------------------------------------------------
STATS
  $ctr=0;
  my $xg = Graph->new;
  foreach my $cluster (
		       sort {scalar(@$b) <=> scalar(@$a)}
		       map {[keys %$_]}
		       values %colors
		      ) {
    my $size = scalar(@$cluster);
    $ctr++;
    my $max = 0;
    foreach my $w (@$cluster) {
      my $v = $nodes{$w}{connectivty};
      $v > $max and $v <= 0.1 and $max=$v;
      foreach my $w2 (@$cluster) {
	next if ($w eq $w2);
	$xg->add_edge($w => $w2) if ($nodes{$w}{adjacencies}{$w2});
      }
    }
    print "<$ctr> size=$size maxc=$max: @$cluster\n";
  }

  print "\n\n\n";

  foreach my $info ( 
		    sort {$b->[2] <=> $a->[2] || $a->[1] <=> $b->[1] }
		    grep {$_->[1] > 1}
		    map {[$_,$nodes{$_}{sons},$nodes{$_}{connectivty}]}
		    keys %nodes
		   ) {
    my ($w,$n,$c) = @$info;
    my @c = ();
    $c == 0 and @c = sort keys %{$nodes{$w}{uadj}};
    print "$w\t$n\t$c\t@c\n";
  }

  my $writer = Graph::Writer::Dot->new();
  $writer->write_graph($xg,"$base.cluster.dot");
}


sub rdf_dump {
#  my $ns = 'http://alpage.inria.fr/words#';
#  my $rdf         = RDF::Trine::Namespace->new('http://www.w3.org/1999/02/22-rdf-syntax-ns#');
#  my $owl = RDF::Trine::Namespace->new('http://www.w3.org/2002/07/owl#');
  my $ns = 'owl:';
  my $storage = new RDF::Trine::Store::Memory;
  my $model = RDF::Trine::Model->new( $storage );
  my $pred = $owl->similar;
  my $onto = $owl->Class;
  foreach my $xnode (values %nodes) {
    my $name = $xnode->{name};
    $name =~ s/\s/_/og;
    $xnode->{rdf} = RDF::Trine::Node::Resource->new("http://www.w3.org/2002/07/owl/$name");
  }
  foreach my $xsource (values %nodes) {
    my $subject = $xsource->{rdf};
#    my $pred = $subject->new('http://alpage.inria.fr/relations#similar');
    foreach my $target (keys %{$xsource->{adjacencies}}) {
      my $object = $nodes{$target}{rdf};
   
      my $s = RDF::Trine::Statement::Quad->new($subject,$pred,$object,$onto);
      $model->add_statement($s);
    }
  }
  open(RDF,"| recode l1..u8 > $base.rdf") || die "can't open $base.rdf: $!";
  my %options = ( namespaces => 
		  {
		   'rdf' => 'http://www.w3.org/1999/02/22-rdf-syntax-ns#',
		   'rdfs' => 'http://www.w3.org/2000/01/rdf-schema#',
		   'owl' => 'http://www.w3.org/2002/07/owl#'
		  },
		);
  my $serializer = new RDF::Trine::Serializer('rdfxml',%options);
  $serializer->serialize_model_to_file(\*RDF,$model);  
  close(RDF);
}


sub owl_dump {
  my $gen= XML::Generator->new(':pretty');
  my %ns = (
	    owl2xml=>"http://www.w3.org/2006/12/owl2-xml#",
	    swrl=>"http://www.w3.org/2003/11/swrl#",
	    rdfs=>"http://www.w3.org/2000/01/rdf-schema#",
	    owl=> "http://www.w3.org/2002/07/owl#",
	    p1=>"http://www.owl-ontologies.com/",
	    xsp=>"http://www.owl-ontologies.com/2005/08/07/xsp.owl#",
	    swrlb=>"http://www.w3.org/2003/11/swrlb#",
	    dcterms=>"http://purl.org/dc/terms/",
	    rdf=>"http://www.w3.org/1999/02/22-rdf-syntax-ns#",
	    protege=>"http://protege.stanford.edu/plugins/owl/protege#",
	    xsd=>"http://www.w3.org/2001/XMLSchema#",
	    geo=>"http://www.w3.org/2003/01/geo/wgs84_pos#",
	    skos=>"http://www.w3.org/2004/02/skos/core#",
	    nao=>"http://newsml.afp.com/iptc-g2/ontology#"
	   );


  my $stateID = sub {
    my ($nskind,$kind,$source,@body) = @_;
    $gen->$kind([$nskind => $ns{$nskind}],
		{'rdf:ID' => $source},
		@body
	       );
  };

  my $xml = $gen->xml(
		      $gen->RDF([%ns],
				{'xml:base' => "http://alpage.inria.fr/ontology/SCRIBO"}),
		      $gen->Ontology([owl => $ns{owl}],
				     {'rdf:about' => ''})
		     );
  print $xml;
}

sub distrib {
  my $wdistrib = "$base.distrib";
  print "missing $wdistrib" unless (-r $wdistrib);
  open(D,"<$wdistrib") || die "can't open $wdistrib: $!";
  my $all=0;
  my $fall=0;
  my %distrib = ();
  my $pos = {};
  while (<D>) {
    chomp;
    my ($w,$f) = split(/\t/,$_);
    my $p = floor(log10($f));
    my $u = $distrib{$p} ||= [0,0,0,0,0,{}];
    $u->[0]++;
    $all++;
    my ($wpos) = ($w =~ /_([^_]+)$/);
    my $posentry = $pos->{$wpos} ||= { n => 0, 
				       seln => 0
				     };
    $posentry->{n}++;
    $posentry->{seln}++ if (exists $nodes{$w});
    $nodes{$w}{n} = $f if (exists $nodes{$w}
			   && !$nodes{$w}{n});
    my $v = $u->[5]{$wpos} ||= [0,0,0,0,0];
    $v->[0]++;
    $v->[1]++ if (exists $nodes{$w});
  }
  close(D);
  foreach my $p (map { floor(log10($_->{n})) }
		 values %nodes) {
    my $u = $distrib{$p} ||= [0,0,0,0,0];
    $u->[1]++;
    $fall++;
  }

  my $tbpos = Text::Table->new(qw{pos #words #kept %k/w});
  foreach my $wpos (sort {$pos->{$b}{n} <=> $pos->{$a}{n}} 
		    keys %$pos) {
    my $posentry=$pos->{$wpos};
    my $n =     $posentry->{n};
    my $seln = $posentry->{seln};
    $tbpos->add(
	     $wpos,
	     $n, $seln,
	     (map {sprintf("%5.2f%%",$_)} 100*$seln / $n)
	    )

  }
  print $tbpos;
  print "\n";
  my $tb = Text::Table->new(qw{frequency \#words \#kept %words %kept %k/w});
  foreach my $v (sort {$b <=> $a} keys %distrib) {
    my $u = $distrib{$v};
    $u->[2] = $u->[0] / ($all || 1);
    $u->[3] = $u->[1] / ($fall || 1);
    $u->[0] and $u->[4] = $u->[1] / $u->[0];
    $tb->add(
	     $v,
	     $u->[0], $u->[1],
	     (map {sprintf("%5.2f%%",$_)} 100*$u->[2], 100*$u->[3], 100*$u->[4])
	    )
  }
  $tb->add(
	   "total",$all,$fall,
	   (map {sprintf("%5.2f%%",$_)} 100, 100, 100*$fall/$all)
	  );
  print $tb;

  my @bestpos = qw{np nc v adj adv};
  my $tb2pos = Text::Table->new('freq/pos',@bestpos);
  foreach my $p (sort {$b <=> $a} keys %distrib) {
    my $entry = $distrib{$p};
    my $u = $entry->[5];
    my @line = ();
    foreach my $wpos (@bestpos) {
      my $v = $u->{$wpos} || [0,0];
      my ($posn,$possel) = @$v;
      push(@line,
	   sprintf("%.2f%% (%d:%d)",
		   100 * $possel / ($posn || 1),$possel,$posn));
    }
    $tb2pos->add($p,@line);
  }
  print "\n";
  print $tb2pos;


  print <<EOF;

Most frequent registered words:
EOF

  foreach my $w ( sort {$nodes{$b}{n} <=> $nodes{$a}{n}}
		  grep {$nodes{$_}{n} > 100000}
		  keys %nodes ) {
    print "\t$w $nodes{$w}{n}\n";
  }
}

sub check_toefl {
  my $test = shift;
  -f $test or die "Missing toefl test $test";
  my $tests = {};
  open(T,"<$test") || die "can't open tofl test $test: $!";
  while (<T>) {
    if (my ($id,@words) = /^test\s+id=(\d+)\s+"(.+?)"\s+"(.+?)"\s+"(.+?)"\s+"(.+?)"\s+"(.+?)"/) {
      ##      print "registered test id=$id words=@words\n";
      $tests->{$id} = [ @words ];
    }
  }
  close(T);
  print <<EOF;
Test file=$test
EOF
##  check_toelf_dist(20,$tests,$test);
##  check_toelf_dist(10,$tests,$test);
  check_toelf_dist(0,$tests,$test);
  check_toelf_dist(1,$tests,$test);
  check_toelf_dist(2,$tests,$test);
  check_toelf_dist(3,$tests,$test);
  check_toelf_dist(4,$tests,$test);
  check_toelf_dist(5,$tests,$test);
  check_toelf_dist(6,$tests,$test);
  check_toelf_dist(7,$tests,$test,1);
#  check_toelf_dist(8,$tests,$test);
#  check_toelf_dist(9,$tests,$test,1);
#  check_toelf_dist(10,$tests,$test);
#  check_toelf_dist(20,$tests,$test,1);
}

my $paths = {};

sub check_toelf_dist {
  my ($dist,$tests,$test,$display) = @_;
  my %checked = ();
  ##  $paths = {};
  foreach my $w1 (keys %$paths) {
    delete $paths->{$w1}{$_}
      foreach (grep {$paths->{$w1}{$_} == 100000} keys %{$paths->{$w1}});
  }
  my $ok = 0;
  my $bad = 0;
  my $score = 0;
  foreach my $id (sort {$a <=> $b} keys %$tests) {
    my ($candidate,$answer,@wrongs) = @{$tests->{$id}};
    unless ($candidate) {
      next;
      $score++ unless (int(rand(4)));
      next;
    }
    $candidate = normalize($candidate);
    $answer = normalize($answer);
    ##    print "check test=$id candidate=$candidate answer=$answer\n";
    ## ** WARNING ** we only count test where the candidate and the answer are in our vocabulary
    unless (exists $nodes{$candidate} 
	    && exists $nodes{$answer}
	    && ((grep {exists $nodes{$_}} @wrongs) ge 3)
	   ) {
      next;
      int(rand(4)) or $score++;
      next;
    }
    my $entry = $checked{$id} = { ok => 0, bad => 0 };
    my $answer_dist = check_shortest_path($dist,$candidate,$answer);
    my $wrong_dist = 100000;
    my $y;
    foreach my $wrong (map {normalize($_)} @wrongs) {
      my $x = check_shortest_path($dist,$candidate,$wrong);
      if ($x < $wrong_dist) {
	$wrong_dist = $x;
	$y = $wrong;
      }
    }
    if ($answer_dist < $wrong_dist) {
      $ok++;
      $entry->{ok}++;
      $score++;
    } elsif ($wrong_dist < 100000) {
      $bad++;
      $entry->{bad} = $y;
    } else {
      int(rand(4)) or $score++;
    }
  }
  my $checked = scalar(keys %checked);
  my $rok = sprintf("%.2f%%",100 * $ok / ($checked || 1));
  my $rbad = sprintf("%.2f%%",100 * $bad / ($checked || 1));
  my $n = scalar(keys %$tests);
  my $rn = sprintf("%.2f%%",100 * $checked / ($n || 1));
##  my $rscore = sprintf("%.2f%%",100 * $score / ($n || 1));
  my $rscore = sprintf("%.2f%%",100 * $score / ($checked || 1));
  my $delta = sprintf("%.2f%%",100 * ($ok-$bad) / ($checked || 1));
  print <<EOF;
checked d=$dist: $checked/$n ($rn) ok: $ok ($rok) bad: $bad ($rbad) delta=$delta score=$rscore
EOF
  $display or return;
  print "\n";
  ## distrib
  my %pos = ();
  foreach my $id (keys %checked) {
    my $entry = $tests->{$id};
    my $candidate = $entry->[0];
    my ($pos) = $candidate =~ /_(\S+?)$/;
    my $stats = $pos{$pos} ||= { ok => 0, bad => 0, missing => 0 };
    my $res = $checked{$id};
    $stats->{total}++;
    if ($res->{ok}) {
      $stats->{ok}++;
    } elsif ($res->{bad}) {
      $stats->{bad}++;
    } else  {
      $stats->{missing}++;
    }
  }
  print <<EOF;
Distrib
pos	total	ok	bad	missing
EOF
  foreach my $p (sort {$a <=> $b} keys %pos) {
    my $i = $pos{$p};
    print "$p\t$i->{total}\t$i->{ok}\t$i->{bad}\t$i->{missing}\n";
  }
  print"\n\n";
  ##
  print "\n";
  foreach my $id (sort {$a <=> $b} keys %checked) {
    my $entry = $tests->{$id} || [];
    my $res = $checked{$id};
    my $wrong = $res->{bad};
    if ($wrong) {
      my @entry = map {$_ eq $wrong ? "*$_" : "$_"} @$entry;
      print <<EOF;
test $id [0 1] @entry
EOF
    } else {
      print <<EOF;
test $id [$res->{ok} $res->{bad}] @$entry
EOF
    }
  }
}

sub check_shortest_path {
  my ($d,$w1,$w2) = @_;
  $w1 eq $w2 and return 0;
  my $default = 100000;
  return $default unless ( $d 
			   && exists $nodes{$w1} 
			   && exists $nodes{$w2}
#			   && exists $wng->{$w1}
#			   && exists $wng->{$w2}
			 );
  ($w1,$w2) = sort ($w1,$w2);
  exists $paths->{$w1}{$w2} and return $paths->{$w1}{$w2};
  my ($xw1,$xw2) = @nodes{$w1,$w2};
  $d--;
  $default--;
  return $paths->{$w1}{$w2} =
    1+min(min( $default,
	       map { check_shortest_path($d,$_,$w2) } 
	       keys %{$xw1->{adjacencies}}
	     ),
	  min( $default,
	       map { check_shortest_path($d,$_,$w1) } 
	       keys %{$xw2->{adjacencies}}
	     )
	 );
}

sub normalize {
  my $w = shift;
  $w =~ s/^s'/se_/o;
  $w =~ s/^se /se/o;
  return $w;
}

sub load_wordnet {
  my $file = shift;

  if ($file =~ /\.bz2/) {
    open(W,"bzcat $file|") || die "can't open $file: $!";
  } else {
    open(W,"<$file") || die "can't open $file: $!";
  }

  my $wn = [];
  my $synset;
  my $entry;
  my $pos;
  my $delay={};			# for wolf

  while (<W>) {
    if (/^0\s+\@(\d+)\@\s+WORD_MEANING/) {
      ## emit_synset() if ($synset);
      $synset = $1;
      $entry = [];
      push(@$wn,$entry);
      next;
    }
    if (/^\s+1\s+PART_OF_SPEECH\s+"(.+?)"/) {
      push(@$entry,$1);
      $pos = $1;
      next;
    }
    if (/^\s+2\s+LITERAL\s+"(.+?)"/) {
      my $w = attach_pos($1,$pos);
      push(@$entry,$w);
      next;
    }
    
    ## add hyperonyms in synset
    if (1 
	##/^\s+2\s+RELATION\s+"(has_hyperonym|antonym|has_meronym|is_subevent_of)"/
	&& /^\s+2\s+RELATION/
       ) {
      my $pos2;
      while(<W>) {
	$pos2=$1, next if (/^\s+4\s+PART_OF_SPEECH\s+"(.+?)"/);
	if (/^\s+4\s+LITERAL\s+"(.+?)"/) {
	  my $w = attach_pos($1,$pos2);
	  push(@$entry,$w);
	  last;
	}
      }
    }
    
    ## reading my own format
    if (/^begin\s+synset\s+(\S+?)\s+pos=(\w)/) {
      $synset = $1;
      $entry = [$2];
      $pos = $2;
      push(@$wn,$entry);
      my $rels = [];
      $delay->{$synset} = { entry => $entry, rels => $rels };
      while (<W>) {
	last if /^end\s+synset/;
	chomp;
	s/\s+$//og;
	if (/\#ilr type=(\S+)\s+id=(\S+)/) {
	  push(@$rels,[$1,$2]);
	  next;
	}
	my $w = attach_pos($_,$pos);
	push(@$entry,$w);
      }
      next;
    }

    ## reading dot
    if (/"(.+?)"\s+\->\s+"(.+?)"\s+.*;/) {
      push(@$wn,['toto',$1,$2]);
      next;
    }

    ## wolf format
    if (m{<SYNSET><ID>(\S+?)</ID>}) {
      my $id = $1;
      next unless (/<LITERAL>/);
      my $line = $_;
      my ($pos) = ($line =~ m{<POS>(.+?)</POS>}o);
      my @synset=();
      while ($line =~ m{<LITERAL>(.+?)<}og) {
	my $w = attach_pos($1,$pos);
##	print "Litteral $w\n";
	push(@synset,$w);
      }
      my $entry = [$pos,@synset];
      my $rels = [];
      push(@$wn,$entry);
      $delay->{$id} = { entry => $entry ,
			rels => $rels
		      };
      while ($line =~ m{<ILR><TYPE>(.+?)</TYPE>(.+?)</ILR>}og) {
	my $rel= $1;
	my $tid= $2;
	push(@$rels,[$rel,$tid]);
      }
      next;
    }
    
  }

  close(W);

  my $wng = {};

  foreach my $synset (@$wn) {
    my @entry = @$synset;
    shift @entry;
    while (@entry) {
      my $w1 = shift @entry;
      $wng->{$w1} ||= {};
      foreach my $w2 (@entry) {
	next if ($w1 eq $w2);
	$wng->{$w1}{$w2} = 1;
	$wng->{$w2}{$w1} = 1;
      }
    }
  }

  ## wordnet read in XML format (Wolf) 
  foreach my $x (values %$delay) {
    my $entry = $x->{entry};
    foreach my $rel (@{$x->{rels}}) {
      my ($r,$tid) = @$rel;
      my $target = $delay->{$tid};
      next unless ($target);
      my $tentry=$target->{entry};
      my @entry1 = @$entry;
      shift @entry1;
      my @entry2 = @$tentry;
      shift @entry2;
      foreach my $w1 (@entry1) {
	foreach my $w2 (@entry2) {
	  next if ($w1 eq $w2);
	  $wng->{$w1}{$w2} = 1;
	  $wng->{$w2}{$w1} = 1;
	}
      }
    }
  }
  
  return $wng;

}

my $wn_paths = {};

sub test_wordnet {
  my $file = shift;
  my $wng = load_wordnet($file);

  my $wn_words = scalar(keys %$wng);
  my @wn_words = keys %$wng;
  my $wn_edges=0;
  my $edges2 = 0;
  
  foreach my $w1 (keys %$wng) {
    my @k = keys %{$wng->{$w1}};
    $wn_edges += scalar(grep {($_ cmp $w1) > 0} @k);
    (exists $nodes{$w1}) and $edges2 += scalar(grep {exists $nodes{$_} && ($_ cmp $w1) > 0} @k);
  }

  my $dump_words = scalar(keys %nodes);
  my $dump_edges = 0;
  my $intersect_words = 0;
  my $edges1 = 0;
  
  foreach my $w1 (keys %nodes) {
    my @k = keys %{$nodes{$w1}{adjacencies}};
    $dump_edges += scalar(@k);
    (exists $wng->{$w1}) or next;
    $intersect_words++;
    $edges1 += scalar(grep {exists $wng->{$_}} @k);
  }

  my $ok=0;
  my $bad=0;
  my @ok=();
  my @bad=();
  my $seen = {};
  my $r=0;

  my @ok2=();
  my @bad2=();
  my $seen2={};
  my $r2=0;
  my $ok2=0;
  my $bad2=0;

  my @random = ();
  for( my $i=0; $i < 1000; $i++) {
    my $w1 = $wn_words[int(rand($wn_words))];
    my $w2 = $wn_words[int(rand($wn_words))];
    next unless ($w1 cmp $w2 > 0);
    next unless (exists $nodes{$w1} && exists $nodes{$w2});
    push(@random,[$w1,$w2]);
  }

  my $test = sub {
    my ($dist) = @_;
    delete $seen->{$_->[0]}{$_->[1]} foreach (@bad);
    @bad = ();
    $bad = 0;
    foreach my $tmp1 (values %$wn_paths) {
      delete $tmp1->{$_}
	foreach (grep {$tmp1->{$_} == 100000} keys %$tmp1);
    }

    ## test dump edges
    foreach my $w1 (grep {$wng->{$_}} keys %nodes) {
      next if ($intersect_words > 5000 && int(rand(10)));
      foreach my $w2 (grep {$wng->{$_}} keys %{$nodes{$w1}{adjacencies}}) {
	next if (exists $seen->{$w2}{$w1} || exists $seen->{$w1}{$w2});
	$seen->{$w1}{$w2} = 1;
	if ((my $d = wn_check_shortest_path($wng,$dist,$w1,$w2)) <= $dist) {
	  $ok++;
	  push(@ok,[$w1,$w2,$d]);
	  $r += 1 / $d;
	} else {
	  $bad++;
	  push(@bad,[$w1,$w2]);
	}
      }
    }

    delete $seen2->{$_->[0]}{$_->[1]} foreach (@bad2);
    @bad2 = ();
    $bad2 = 0;
    foreach my $tmp1 (values %$paths) {
      delete $tmp1->{$_} 
	foreach (grep {$tmp1->{$_} == 100000} keys %$tmp1);
    }

    ## test wn edges
    foreach my $w1 (grep {exists $nodes{$_}} keys %$wng) {
      next if ($intersect_words > 5000 && int(rand(10)));
      foreach my $w2 (grep {exists $nodes{$_}} keys %{$wng->{$w1}}) {
	next if (exists $seen2->{$w2}{$w1} || exists $seen2->{$w1}{$w2});
	$seen2->{$w1}{$w2} = 1;
	if ((my $d = check_shortest_path($dist,$w1,$w2)) <= $dist) {
	  $ok2++;
	  push(@ok2,[$w1,$w2,$d]);
	  $r2 += 1 / $d;
	} else {
	  $bad2++;
	  push(@bad2,[$w1,$w2]);
	}
      }
    }

    my $x=0;
    foreach (@random) {
      (wn_check_shortest_path($wng,$dist,@$_) <= $dist) and $x++;
    }

    my $prec = $ok / $edges1;
    my $rec = $ok2 / $edges2;
    my $f = 2 * ($prec * $rec) / (($prec + $rec) || 0.1);

    my $xprec = $r / $edges1;
    my $xrec = $r2 / $edges2;
    my $xf = 2 * ($xprec * $xrec) / (($xprec + $xrec) || 0.1);

    printf "dist=%d: ok=%d bad=%d prec=%.2f%% recall=%.2f%% f=%.2f%% xprec=%.2f xrec=%.2f xf=%.2f random=%.2f%%\n",
      $dist,
	$ok,
	  $bad,
	    100 * $prec,
	      100 * $rec,
		100 * $f,
		  100 * $xprec,
		    100 * $xrec,
		      100 * $xf,
			$x / 10
			  ;
  };
  
  print <<EOF;
Test wordnet $file
wordnet    words: $wn_words edges: $wn_edges
dump       words: $dump_words edges: $dump_edges
intersect  words: $intersect_words wn_subedges=$edges2 dump_subedges=$edges1

EOF
  $test->($_) foreach (qw/0 1 2 3 4 5 6 7 8 9 10/);
#  $test->($_) foreach (qw/1 10/);
  unless ($config->wndump) {
    print "\n\nok edges\n";
    print "ok=$_->[2] $_->[0] $_->[1]\n" foreach (sort {$a->[2] <=> $b->[2]} @ok);
    print "\n\nbad edges\n";
    print "bad @$_\n" foreach (@bad) 
  };
}


sub test_xwordnet {
  my $file = shift;
  my $wng = load_wordnet($file);

  my $wn_words = scalar(keys %$wng);
  my @wn_words = keys %$wng;
  my $wn_edges=0;
  my $edges2 = 0;
  foreach my $w1 (keys %$wng) {
    $wn_edges += scalar(grep {($_ cmp $w1) > 0} 
			keys %{$wng->{$w1}});
    $edges2 += scalar(grep {exists $nodes{$_} && ($_ cmp $w1) > 0} 
		      keys %{$wng->{$w1}})
      if (exists $nodes{$w1});
  }
  my $dump_words = scalar(keys %nodes);
  my $dump_edges = 0;
  my $intersect_words = 0;
  my $edges1 = 0;
  foreach my $w1 (keys %nodes) {
    $intersect_words++ if (exists $wng->{$w1});
    $dump_edges += scalar(keys %{$nodes{$w1}{adjacencies}});
    $edges1 += scalar(grep {exists $wng->{$_}}
		      keys %{$nodes{$w1}{adjacencies}})
      if (exists $wng->{$w1});
  }

  
  print <<EOF;
Test wordnet $file
wordnet    words: $wn_words edges: $wn_edges
dump       words: $dump_words edges: $dump_edges
intersect  words: $intersect_words wn_subedges=$edges2 dump_subedges=$edges1

EOF

  my $ok=0;
  my $bad=0;
  my @ok=();
  my @bad=();
  my $seen = {};
  my $r=0;
  my $dist = 10;

  my $sum = 0;
  my $nb=0;
  
  foreach my $w1 (keys %nodes) {
    next unless (exists $wng->{$w1});
    foreach my $w2 (keys %{$nodes{$w1}{adjacencies}}) {
      next unless (exists $wng->{$w2});
      next if (exists $seen->{$w2}{$w1}
	       || exists $seen->{$w1}{$w2}
	      );
      $seen->{$w1}{$w2} = 1;
      $nb++;
      my $d = wn_check_shortest_path($wng,$dist,$w1,$w2);
      if ($d <= $dist) {
	$ok++;
	push(@ok,[$w1,$w2,$d]);
	$r += 1 / $d;
      } else {
	$bad++;
	push(@bad,[$w1,$w2]);
      }
    }
  }

  $r = 100 * $r / $nb;

  my $x=0;

  printf "ok=%d bad=%d r=%.2f nb=%d\n",
      $ok,
	$bad,
	  $r,
	    $nb ;

  print "\n\nok edges\n";
  print "ok=$_->[2] $_->[0] $_->[1]\n" foreach (sort {$a->[2] <=> $b->[2]} @ok);
  print "\n\nbad edges\n";
  print "bad @$_\n" foreach (@bad);
}

sub attach_pos {
  my ($w,$pos) = @_;
  my $xpos = $pos{$pos} || $pos;
  return "${w}_${xpos}";
}

sub wn_check_shortest_path {
  my ($wng,$d,$w1,$w2) = @_;
  my $default = 100000;
  ($w1 eq $w2) and return 0;
  return $default unless ($d 
			  && exists $wng->{$w1} 
			  && exists $wng->{$w2}
			  && exists $nodes{$w1} 
			  && exists $nodes{$w2}
			 );
  ($w1,$w2) = sort ($w1,$w2);
  (exists $wn_paths->{$w1}{$w2}) and return $wn_paths->{$w1}{$w2};
  my ($xw1,$xw2) = @{$wng}{$w1,$w2};
  $d--;
  $default--;
  return $wn_paths->{$w1}{$w2} =  
    1+min( $default,
	   ( map {wn_check_shortest_path($wng,$d,$_,$w2)} keys %$xw1 ),
	   ( map {wn_check_shortest_path($wng,$d,$w1,$_)} keys %$xw2 )
	 );
}
